require 'net/http'
require 'net/https'
require 'uri'
require 'jwt'

module CommonEngine
  module FullcalendarUtility
    extend ActiveSupport::Concern

    def prepare_fullcalendar
      @weekday_names = get_weekday_names().to_json.html_safe
      @weekday_short_names = get_weekday_short_names().to_json.html_safe
      @empty_event_title = t('common.empty_event_title')
      @title_format_month = t('format.fullcalendar.title.month')
      @title_format_week = t('format.fullcalendar.title.week').html_safe
      @title_format_day = t('format.fullcalendar.title.day').html_safe
      @month_text = t('format.fullcalendar.button_text.month')
      @week_text = t('format.fullcalendar.button_text.week')
      @day_text = t('format.fullcalendar.button_text.day')
      @today_text = t('format.fullcalendar.button_text.today')
    end

    private
      def get_weekday_names
        return [
          t('common.weekday_names.Sunday'),
          t('common.weekday_names.Monday'),
          t('common.weekday_names.Tuesday'),
          t('common.weekday_names.Wednesday'),
          t('common.weekday_names.Thursday'),
          t('common.weekday_names.Friday'),
          t('common.weekday_names.Saturday')
        ]
      end
      def get_weekday_short_names
        return [
          t('common.weekday_names.short.Sunday'),
          t('common.weekday_names.short.Monday'),
          t('common.weekday_names.short.Tuesday'),
          t('common.weekday_names.short.Wednesday'),
          t('common.weekday_names.short.Thursday'),
          t('common.weekday_names.short.Friday'),
          t('common.weekday_names.short.Saturday')
        ]
      end
  end
end
