class ApplicationBaseRecord < ActiveRecord::Base
  self.abstract_class = true

  def update_opt(*args)
    set_updated_user_args(*args)
    set_updated_at
    begin
      update(*args)
    end
  end

  def save_opt!
    set_created_user
    set_updated_user
    set_updated_at
    begin
      self.save!
    rescue ActiveRecord::RecordNotUnique
      errors.add :base, 'Could not save because of primary key restriction.'
      false
    end
  end

  def destroy_opt!
    set_valid_flg
    set_updated_user
    set_updated_at
    begin
      self.save
    end
  end

  def set_created_user
    raise 'Extend this method'
  end
  def set_updated_user
    raise 'Extend this method'
  end
  def set_updated_user_args(*args)
    raise 'Extend this method'
  end
  def set_updated_at
    self.updated_at = Time.now.utc
  end
  def set_valid_flg
    self.valid_flg = true
  end
end
